/* dsn.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dsn.h"

void *dsnStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dsnEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dsnDasdsnSave(struct dsnDasdsn *obj, int indent, FILE *f)
/* Save dsnDasdsn to file. */
{
struct dsnDsn *dsnDsn;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASDSN>");
fprintf(f, "\n");
for (dsnDsn = obj->dsnDsn; dsnDsn != NULL; dsnDsn = dsnDsn->next)
   dsnDsnSave(dsnDsn, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASDSN>\n");
}

struct dsnDasdsn *dsnDasdsnLoad(char *fileName)
/* Load dsnDasdsn from file. */
{
struct dsnDasdsn *obj;
xapParseAny(fileName, "DASDSN", dsnStartHandler, dsnEndHandler, NULL, &obj);
return obj;
}

void dsnDsnSave(struct dsnDsn *obj, int indent, FILE *f)
/* Save dsnDsn to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DSN>");
fprintf(f, "\n");
dsnSourceSave(obj->dsnSource, indent+2, f);
dsnDescriptionSave(obj->dsnDescription, indent+2, f);
dsnMapmasterSave(obj->dsnMapmaster, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DSN>\n");
}

struct dsnDsn *dsnDsnLoad(char *fileName)
/* Load dsnDsn from file. */
{
struct dsnDsn *obj;
xapParseAny(fileName, "DSN", dsnStartHandler, dsnEndHandler, NULL, &obj);
return obj;
}

void dsnSourceSave(struct dsnSource *obj, int indent, FILE *f)
/* Save dsnSource to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SOURCE");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</SOURCE>\n");
}

struct dsnSource *dsnSourceLoad(char *fileName)
/* Load dsnSource from file. */
{
struct dsnSource *obj;
xapParseAny(fileName, "SOURCE", dsnStartHandler, dsnEndHandler, NULL, &obj);
return obj;
}

void dsnDescriptionSave(struct dsnDescription *obj, int indent, FILE *f)
/* Save dsnDescription to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DESCRIPTION");
if (obj->href != NULL)
    fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</DESCRIPTION>\n");
}

struct dsnDescription *dsnDescriptionLoad(char *fileName)
/* Load dsnDescription from file. */
{
struct dsnDescription *obj;
xapParseAny(fileName, "DESCRIPTION", dsnStartHandler, dsnEndHandler, NULL, &obj);
return obj;
}

void dsnMapmasterSave(struct dsnMapmaster *obj, int indent, FILE *f)
/* Save dsnMapmaster to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<MAPMASTER>");
fprintf(f, "%s", obj->text);
fprintf(f, "</MAPMASTER>\n");
}

struct dsnMapmaster *dsnMapmasterLoad(char *fileName)
/* Load dsnMapmaster from file. */
{
struct dsnMapmaster *obj;
xapParseAny(fileName, "MAPMASTER", dsnStartHandler, dsnEndHandler, NULL, &obj);
return obj;
}

void *dsnStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASDSN"))
    {
    struct dsnDasdsn *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "DSN"))
    {
    struct dsnDsn *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASDSN"))
            {
            struct dsnDasdsn *parent = st->object;
            slAddHead(&parent->dsnDsn, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SOURCE"))
    {
    struct dsnSource *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct dsnDsn *parent = st->object;
            slAddHead(&parent->dsnSource, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct dsnDescription *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct dsnDsn *parent = st->object;
            slAddHead(&parent->dsnDescription, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct dsnMapmaster *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct dsnDsn *parent = st->object;
            slAddHead(&parent->dsnMapmaster, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dsnEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASDSN"))
    {
    struct dsnDasdsn *obj = stack->object;
    if (obj->dsnDsn == NULL)
        xapError(xp, "Missing DSN");
    }
else if (sameString(name, "DSN"))
    {
    struct dsnDsn *obj = stack->object;
    if (obj->dsnSource == NULL)
        xapError(xp, "Missing SOURCE");
    if (obj->dsnSource->next != NULL)
        xapError(xp, "Multiple SOURCE");
    if (obj->dsnDescription != NULL && obj->dsnDescription->next != NULL)
        xapError(xp, "Multiple DESCRIPTION");
    if (obj->dsnMapmaster == NULL)
        xapError(xp, "Missing MAPMASTER");
    if (obj->dsnMapmaster->next != NULL)
        xapError(xp, "Multiple MAPMASTER");
    }
else if (sameString(name, "SOURCE"))
    {
    struct dsnSource *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct dsnDescription *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct dsnMapmaster *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

