/* refAlign.c was originally generated by the autoSql program, which also 
 * generated refAlign.h and refAlign.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "jksql.h"
#include "refAlign.h"

void refAlignStaticLoad(char **row, struct refAlign *ret)
/* Load a row from refAlign table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->chrom = row[0];
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = row[3];
ret->score = sqlUnsigned(row[4]);
ret->matches = sqlUnsigned(row[5]);
ret->misMatches = sqlUnsigned(row[6]);
ret->hNumInsert = sqlUnsigned(row[7]);
ret->hBaseInsert = sqlSigned(row[8]);
ret->aNumInsert = sqlUnsigned(row[9]);
ret->aBaseInsert = sqlSigned(row[10]);
ret->humanSeq = row[11];
ret->alignSeq = row[12];
ret->attribs = row[13];
}

struct refAlign *refAlignLoad(char **row)
/* Load a refAlign from row fetched with select * from refAlign
 * from database.  Dispose of this with refAlignFree(). */
{
struct refAlign *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = cloneString(row[3]);
ret->score = sqlUnsigned(row[4]);
ret->matches = sqlUnsigned(row[5]);
ret->misMatches = sqlUnsigned(row[6]);
ret->hNumInsert = sqlUnsigned(row[7]);
ret->hBaseInsert = sqlSigned(row[8]);
ret->aNumInsert = sqlUnsigned(row[9]);
ret->aBaseInsert = sqlSigned(row[10]);
ret->humanSeq = cloneString(row[11]);
ret->alignSeq = cloneString(row[12]);
ret->attribs = cloneString(row[13]);
return ret;
}

struct refAlign *refAlignLoadAll(char *fileName) 
/* Load all refAlign from a tab-separated file.
 * Dispose of this with refAlignFreeList(). */
{
struct refAlign *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[14];

while (lineFileRow(lf, row))
    {
    el = refAlignLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct refAlign *refAlignCommaIn(char **pS, struct refAlign *ret)
/* Create a refAlign out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new refAlign */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
ret->name = sqlStringComma(&s);
ret->score = sqlUnsignedComma(&s);
ret->matches = sqlUnsignedComma(&s);
ret->misMatches = sqlUnsignedComma(&s);
ret->hNumInsert = sqlUnsignedComma(&s);
ret->hBaseInsert = sqlSignedComma(&s);
ret->aNumInsert = sqlUnsignedComma(&s);
ret->aBaseInsert = sqlSignedComma(&s);
ret->humanSeq = sqlStringComma(&s);
ret->alignSeq = sqlStringComma(&s);
ret->attribs = sqlStringComma(&s);
*pS = s;
return ret;
}

void refAlignFree(struct refAlign **pEl)
/* Free a single dynamically allocated refAlign such as created
 * with refAlignLoad(). */
{
struct refAlign *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->name);
freeMem(el->humanSeq);
freeMem(el->alignSeq);
freeMem(el->attribs);
freez(pEl);
}

void refAlignFreeList(struct refAlign **pList)
/* Free a list of dynamically allocated refAlign's */
{
struct refAlign *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    refAlignFree(&el);
    }
*pList = NULL;
}

void refAlignOutput(struct refAlign *el, FILE *f, char sep, char lastSep) 
/* Print out refAlign.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->score);
fputc(sep,f);
fprintf(f, "%u", el->matches);
fputc(sep,f);
fprintf(f, "%u", el->misMatches);
fputc(sep,f);
fprintf(f, "%u", el->hNumInsert);
fputc(sep,f);
fprintf(f, "%d", el->hBaseInsert);
fputc(sep,f);
fprintf(f, "%u", el->aNumInsert);
fputc(sep,f);
fprintf(f, "%d", el->aBaseInsert);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->humanSeq);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->alignSeq);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->attribs);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

